#include "postgres.h"
#include "postgres_fe.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <replicate_com.h>
#include <pthread.h>
#include "libpq-fe.h"
#include "libpq-int.h"
#include "fe-auth.h"  

#include "pgreplicate.h"

ConfDataType * ConfData_Top = (ConfDataType *)NULL;
ConfDataType * ConfData_End = (ConfDataType *)NULL;

RPLMonStat	comm;

int main(int argc, char **argv)
{
        int		ret, sock, n;
        unsigned short	port;

        printf("RPLMonitor v1.0\n");
        if (argc != 3)
        {
          printf("Usage: %s hostname port\n", argv[0]);
          return 0;
        }
        if (atoi(argv[2]) > 0)
        {
#ifdef WIN32
          WORD wVersionRequested;
          WSADATA wsaData;
          int err;

          wVersionRequested = MAKEWORD( 1, 1 );
          err = WSAStartup( wVersionRequested, &wsaData );
          if ( err != 0 )
          {
            printf("WSAStartup failed");
            return 0;
          }
#endif
          port = atoi(argv[2]);
          ret = PGR_Create_Socket_Connect(&sock, argv[1], port);
          if (ret != STATUS_OK)
          {
            printf("PGR_Create_Socket_Connect() failed\n");
            return 1;
          }

          n = 0;
          while ((ret = read(sock, &comm, sizeof(comm))) > 0)
          {
            comm.port = ntohl(comm.port);
            comm.n_begin = ntohl(comm.n_begin);
            comm.n_commit = ntohl(comm.n_commit);
            comm.n_rollback = ntohl(comm.n_rollback);
            comm.n_ddlstmt = ntohl(comm.n_ddlstmt);
            comm.n_insert = ntohl(comm.n_insert);
            comm.n_update = ntohl(comm.n_update);
            comm.n_delete = ntohl(comm.n_delete);
            n++;
            printf("DB server #%d\n"
                    "\tHostname: %s\n"
                    "\tResolved host: %s\n"
                    "\tPort: %d\n"
                    "\t# of started transactions: %d\n"
                    "\t# of COMMITed transactions: %d\n"
                    "\t# of ROLLBACKed transactions: %d\n"
                    "\t# of INSERT statements: %d\n"
                    "\t# of UPDATE statements: %d\n"
                    "\t# of DELETE statements: %d\n"
                    "\t# of DDL statements: %d\n",
                      n,
                      comm.hostName,
                      comm.resolvedName,
                      comm.port,
                      comm.n_begin,
                      comm.n_commit,
                      comm.n_rollback,
                      comm.n_insert,
                      comm.n_update,
                      comm.n_delete,
                      comm.n_ddlstmt);
          }

          printf("%d active cluster members were found\n", n);
          PGR_Close_Sock(&sock);
#ifdef WIN32
          WSACleanup();
#endif
        }
        return 0;
}
