/*-------------------------------------------------------------------------
 *
 * waitpid.c
 *        Wait for a child matching PID to die.
 *
 * Copyright (c) 2006, Cybertec Geschwinde & Schönig GmbH
 *
 *
 *-------------------------------------------------------------------------
 */

#include "c.h"
#include <errno.h>

pid_t
waitpid (pid_t pid, int *stat_loc, int options)
{
	HANDLE		hProcess;
	DWORD		status;

	if ((options & ~(WNOHANG|WUNTRACED)) != 0) {
		errno = EINVAL;
		return (pid_t) -1;
	}
	if ((pid == -1) || (pid == -2)) {
		errno = ECHILD;
		return -1;
	}
	hProcess = OpenProcess (SYNCHRONIZE, FALSE, pid);
	if (hProcess == NULL) {
		set_werrno;
		return -1;
	}
	if (WaitForSingleObject (hProcess, (DWORD) (-1L)) == WAIT_FAILED) {
		set_werrno;
		return -1;
	}
	if (!GetExitCodeProcess (hProcess, &status)) {
		set_werrno;
		return -1;
	}
	if (!stat_loc)
		*stat_loc = status;
	CloseHandle (hProcess);
	return pid;  
}

